﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage;
using Windows.Storage.Streams;


namespace fileOperatApp
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class Page1 : Page
    {
        public Page1()
        {
            this.InitializeComponent();
        }

        private async void OnWrite(object sender, RoutedEventArgs e)
        {
            string content = null;
            edtbox.Document.GetText(Windows.UI.Text.TextGetOptions.UseCrlf, out content);
            if (string.IsNullOrEmpty(content))
            {
                return;
            }

            ButtonBase b = sender as ButtonBase;
            b.IsEnabled = false;

            // 获取文档库
            StorageFolder doclib = KnownFolders.DocumentsLibrary;
            // 创建新文件
            StorageFile newfile = await doclib.CreateFileAsync("test.txt", CreationCollisionOption.OpenIfExists);
            this.Tag = newfile.Name;

            // 将文本写入文件
            await FileIO.WriteTextAsync(newfile, content, UnicodeEncoding.Utf8);

            b.IsEnabled = true;
        }

        private async void OnRead(object sender, RoutedEventArgs e)
        {
            string filename = this.Tag as string;
            if (filename == null) return;

            Button b = sender as Button;
            b.IsEnabled = false;
            string displayContent = null;
            try
            {
                // 访问文档库
                StorageFolder doclib = KnownFolders.DocumentsLibrary;
                // 获取刚才保存的文件
                StorageFile file = await doclib.GetFileAsync(filename);

                if (file != null)
                {
                    // 读入内容
                    displayContent = await FileIO.ReadTextAsync(file, UnicodeEncoding.Utf8);
                }
            }
            catch (FileNotFoundException)
            {
                displayContent = "文件不存在。";
            }
            catch (Exception ex)
            {
                displayContent = ex.Message;
            }

            tb.Text = displayContent;
            b.IsEnabled = true;
        }
    }
}
