﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Storage;
using Windows.Storage.Streams;

namespace fileOperatApp
{
    /// <summary>
    /// 可用于自身或导航至 Frame 内部的空白页。
    /// </summary>
    public sealed partial class Page2 : Page
    {
        public Page2()
        {
            this.InitializeComponent();
        }

        private async void onWrite(object sender, RoutedEventArgs e)
        {
            Button b = sender as Button;
            b.IsEnabled = false;
            // 获取文档库
            StorageFolder doclib = KnownFolders.DocumentsLibrary;
            // 创建文件
            StorageFile file = await doclib.CreateFileAsync("new.txt", CreationCollisionOption.ReplaceExisting);
            Tag = file.Name;
            // 打开文件流
            using (IRandomAccessStream stream = await file.OpenAsync(FileAccessMode.ReadWrite))
            {
                DataWriter dw = new DataWriter(stream);
                // 写入时间
                dw.WriteDateTime(DateTimeOffset.Now);
                // 提交数据到流
                await dw.StoreAsync();
                // 收工
                dw.Dispose();
            }
            b.IsEnabled = true;
        }

        private async void OnRead(object sender, RoutedEventArgs e)
        {
            string filename = Tag as string;
            if (filename == null) return;

            Button b = sender as Button;
            b.IsEnabled = false;
            StorageFolder doclib = KnownFolders.DocumentsLibrary;
            string displaystr = null;
            try
            {
                // 获取文件
                StorageFile file = await doclib.GetFileAsync(filename);
                if (file != null)
                {
                    // 打开流
                    using(IRandomAccessStream stream = await file.OpenReadAsync())
                    {
                        // 读出时间
                        using (DataReader dr=new DataReader(stream))
                        {
                            await dr.LoadAsync((uint)stream.Size);
                            DateTimeOffset dt = dr.ReadDateTime();
                            displaystr = dt.ToString("yyyy年M月d日 HH:mm:ss");
                        }
                    }
                }
            }
            catch (FileNotFoundException)
            {
                displaystr = "未找到文件。";
            }
            catch (Exception ex)
            {
                displaystr = ex.Message;
            }

            msgtb.Text = displaystr;
            b.IsEnabled = true;
        }
    }
}
